Next: Analysis Options, Up: Invoking [Contents]

### 4.1 Output Options

These options specify which of several output formats `gprof` should produce.

Many of these options take an optional symspec to specify functions to be included or excluded. These options can be specified multiple times, with different symspecs, to include or exclude sets of symbols. See Symspecs.

Specifying any of these options overrides the default (‘`-p -q`’), which prints a flat profile and call graph analysis for all functions.

`-A[symspec]`
`--annotated-source[=symspec]`

  The ‘`-A`’ option causes `gprof` to print annotated source code. If symspec is specified, print output only for matching symbols. See The Annotated Source Listing.

`-b`
`--brief`

  If the ‘`-b`’ option is given, `gprof` doesn’t print the verbose blurbs that try to explain the meaning of all of the fields in the tables. This is useful if you intend to print out the output, or are tired of seeing the blurbs.

`-C[symspec]`
`--exec-counts[=symspec]`

  The ‘`-C`’ option causes `gprof` to print a tally of functions and the number of times each was called. If symspec is specified, print tally only for matching symbols.

  If the profile data file contains basic-block count records, specifying the ‘`-l`’ option, along with ‘`-C`’, will cause basic-block execution counts to be tallied and displayed.

`-i`
`--file-info`

  The ‘`-i`’ option causes `gprof` to display summary information about the profile data file(s) and then exit. The number of histogram, call graph, and basic-block count records is displayed.

`-I dirs`
`--directory-path=dirs`

  The ‘`-I`’ option specifies a list of search directories in which to find source files. Environment variable GPROF_PATH can also be used to convey this information. Used mostly for annotated source output.

`-J[symspec]`
`--no-annotated-source[=symspec]`

  The ‘`-J`’ option causes `gprof` not to print annotated source code. If symspec is specified, `gprof` prints annotated source, but excludes matching symbols.

`-L`
`--print-path`

  Normally, source filenames are printed with the path component suppressed. The ‘`-L`’ option causes `gprof` to print the full pathname of source filenames, which is determined from symbolic debugging information in the image file and is relative to the directory in which the compiler was invoked.

`-p[symspec]`
`--flat-profile[=symspec]`

  The ‘`-p`’ option causes `gprof` to print a flat profile. If symspec is specified, print flat profile only for matching symbols. See The Flat Profile.

`-P[symspec]`
`--no-flat-profile[=symspec]`

  The ‘`-P`’ option causes `gprof` to suppress printing a flat profile. If symspec is specified, `gprof` prints a flat profile, but excludes matching symbols.

`-q[symspec]`
`--graph[=symspec]`

  The ‘`-q`’ option causes `gprof` to print the call graph analysis. If symspec is specified, print call graph only for matching symbols and their children. See The Call Graph.

`-Q[symspec]`
`--no-graph[=symspec]`

  The ‘`-Q`’ option causes `gprof` to suppress printing the call graph. If symspec is specified, `gprof` prints a call graph, but excludes matching symbols.

`-t`
`--table-length=num`

  The ‘`-t`’ option causes the num most active source lines in each source file to be listed when source annotation is enabled. The default is 10.

`-y`
`--separate-files`

  This option affects annotated source output only. Normally, `gprof` prints annotated source files to standard-output. If this option is specified, annotated source for a file named `path/filename` is generated in the file `filename-ann`. If the underlying file system would truncate `filename-ann` so that it overwrites the original `filename`, `gprof` generates annotated source in the file `filename.ann` instead (if the original file name has an extension, that extension is replaced with `.ann`).

`-Z[symspec]`
`--no-exec-counts[=symspec]`

  The ‘`-Z`’ option causes `gprof` not to print a tally of functions and the number of times each was called. If symspec is specified, print tally, but exclude matching symbols.

`-r`
`--function-ordering`

  The ‘`--function-ordering`’ option causes `gprof` to print a suggested function ordering for the program based on profiling data. This option suggests an ordering which may improve paging, tlb and cache behavior for the program on systems which support arbitrary ordering of functions in an executable.

  The exact details of how to force the linker to place functions in a particular order is system dependent and out of the scope of this manual.

`-R map_file`
`--file-ordering map_file`

  The ‘`--file-ordering`’ option causes `gprof` to print a suggested .o link line ordering for the program based on profiling data. This option suggests an ordering which may improve paging, tlb and cache behavior for the program on systems which do not support arbitrary ordering of functions in an executable.

  Use of the ‘`-a`’ argument is highly recommended with this option.

  The map_file argument is a pathname to a file which provides function name to object file mappings. The format of the file is similar to the output of the program `nm`.

      c-parse.o:00000000 T yyparse
      c-parse.o:00000004 C yyerrflag
      c-lang.o:00000000 T maybe_objc_method_name
      c-lang.o:00000000 T print_lang_statistics
      c-lang.o:00000000 T recognize_objc_keyword
      c-decl.o:00000000 T print_lang_identifier
      c-decl.o:00000000 T print_lang_type
      …

  To create a map_file with GNU `nm`, type a command like `nm --extern-only --defined-only -v --print-file-name program-name`.

`-T`
`--traditional`

  The ‘`-T`’ option causes `gprof` to print its output in “traditional” BSD style.

`-w width`
`--width=width`

  Sets width of output lines to width. Currently only used when printing the function index at the bottom of the call graph.

`-x`
`--all-lines`

  This option affects annotated source output only. By default, only the lines at the beginning of a basic-block are annotated. If this option is specified, every line in a basic-block is annotated by repeating the annotation for the first line. This behavior is similar to `tcov`’s ‘`-a`’.

`--demangle[=style]`
`--no-demangle`

  These options control whether C++ symbol names should be demangled when printing output. The default is to demangle symbols. The `--no-demangle` option may be used to turn off demangling. Different compilers have different mangling styles. The optional demangling style argument can be used to choose an appropriate demangling style for your compiler.

Next: Analysis Options, Up: Invoking [Contents]